diff -ruN tarsnap-autoconf-1.0.32/config.aux/missing tarsnap-autoconf-1.0.33/config.aux/missing
--- tarsnap-autoconf-1.0.32/config.aux/missing	2012-02-22 04:10:55.000000000 -0800
+++ tarsnap-autoconf-1.0.33/config.aux/missing	2012-08-10 00:05:26.000000000 -0700
@@ -1,10 +1,9 @@
 #! /bin/sh
 # Common stub for a few missing GNU programs while installing.
 
-scriptversion=2009-04-28.21; # UTC
+scriptversion=2012-01-06.18; # UTC
 
-# Copyright (C) 1996, 1997, 1999, 2000, 2002, 2003, 2004, 2005, 2006,
-# 2008, 2009 Free Software Foundation, Inc.
+# Copyright (C) 1996-2012 Free Software Foundation, Inc.
 # Originally by Fran,cois Pinard <pinard@iro.umontreal.ca>, 1996.
 
 # This program is free software; you can redistribute it and/or modify
@@ -26,7 +25,7 @@
 # the same distribution terms that you use for the rest of that program.
 
 if test $# -eq 0; then
-  echo 1>&2 "Try \`$0 --help' for more information"
+  echo 1>&2 "Try '$0 --help' for more information"
   exit 1
 fi
 
@@ -34,7 +33,7 @@
 sed_output='s/.* --output[ =]\([^ ]*\).*/\1/p'
 sed_minuso='s/.* -o \([^ ]*\).*/\1/p'
 
-# In the cases where this matters, `missing' is being run in the
+# In the cases where this matters, 'missing' is being run in the
 # srcdir already.
 if test -f configure.ac; then
   configure_ac=configure.ac
@@ -65,7 +64,7 @@
     echo "\
 $0 [OPTION]... PROGRAM [ARGUMENT]...
 
-Handle \`PROGRAM [ARGUMENT]...' for when PROGRAM is missing, or return an
+Handle 'PROGRAM [ARGUMENT]...' for when PROGRAM is missing, or return an
 error status if there is no known handling for PROGRAM.
 
 Options:
@@ -74,21 +73,20 @@
   --run           try to run the given command, and emulate it if it fails
 
 Supported PROGRAM values:
-  aclocal      touch file \`aclocal.m4'
-  autoconf     touch file \`configure'
-  autoheader   touch file \`config.h.in'
+  aclocal      touch file 'aclocal.m4'
+  autoconf     touch file 'configure'
+  autoheader   touch file 'config.h.in'
   autom4te     touch the output file, or create a stub one
-  automake     touch all \`Makefile.in' files
-  bison        create \`y.tab.[ch]', if possible, from existing .[ch]
-  flex         create \`lex.yy.c', if possible, from existing .c
+  automake     touch all 'Makefile.in' files
+  bison        create 'y.tab.[ch]', if possible, from existing .[ch]
+  flex         create 'lex.yy.c', if possible, from existing .c
   help2man     touch the output file
-  lex          create \`lex.yy.c', if possible, from existing .c
+  lex          create 'lex.yy.c', if possible, from existing .c
   makeinfo     touch the output file
-  tar          try tar, gnutar, gtar, then tar without non-portable flags
-  yacc         create \`y.tab.[ch]', if possible, from existing .[ch]
+  yacc         create 'y.tab.[ch]', if possible, from existing .[ch]
 
-Version suffixes to PROGRAM as well as the prefixes \`gnu-', \`gnu', and
-\`g' are ignored when checking the name.
+Version suffixes to PROGRAM as well as the prefixes 'gnu-', 'gnu', and
+'g' are ignored when checking the name.
 
 Send bug reports to <bug-automake@gnu.org>."
     exit $?
@@ -100,8 +98,8 @@
     ;;
 
   -*)
-    echo 1>&2 "$0: Unknown \`$1' option"
-    echo 1>&2 "Try \`$0 --help' for more information"
+    echo 1>&2 "$0: Unknown '$1' option"
+    echo 1>&2 "Try '$0 --help' for more information"
     exit 1
     ;;
 
@@ -122,22 +120,13 @@
     # Not GNU programs, they don't have --version.
     ;;
 
-  tar*)
-    if test -n "$run"; then
-       echo 1>&2 "ERROR: \`tar' requires --run"
-       exit 1
-    elif test "x$2" = "x--version" || test "x$2" = "x--help"; then
-       exit 1
-    fi
-    ;;
-
   *)
     if test -z "$run" && ($1 --version) > /dev/null 2>&1; then
        # We have it, but it failed.
        exit 1
     elif test "x$2" = "x--version" || test "x$2" = "x--help"; then
        # Could not run --version or --help.  This is probably someone
-       # running `$TOOL --version' or `$TOOL --help' to check whether
+       # running '$TOOL --version' or '$TOOL --help' to check whether
        # $TOOL exists and not knowing $TOOL uses missing.
        exit 1
     fi
@@ -149,27 +138,27 @@
 case $program in
   aclocal*)
     echo 1>&2 "\
-WARNING: \`$1' is $msg.  You should only need it if
-         you modified \`acinclude.m4' or \`${configure_ac}'.  You might want
-         to install the \`Automake' and \`Perl' packages.  Grab them from
+WARNING: '$1' is $msg.  You should only need it if
+         you modified 'acinclude.m4' or '${configure_ac}'.  You might want
+         to install the Automake and Perl packages.  Grab them from
          any GNU archive site."
     touch aclocal.m4
     ;;
 
   autoconf*)
     echo 1>&2 "\
-WARNING: \`$1' is $msg.  You should only need it if
-         you modified \`${configure_ac}'.  You might want to install the
-         \`Autoconf' and \`GNU m4' packages.  Grab them from any GNU
+WARNING: '$1' is $msg.  You should only need it if
+         you modified '${configure_ac}'.  You might want to install the
+         Autoconf and GNU m4 packages.  Grab them from any GNU
          archive site."
     touch configure
     ;;
 
   autoheader*)
     echo 1>&2 "\
-WARNING: \`$1' is $msg.  You should only need it if
-         you modified \`acconfig.h' or \`${configure_ac}'.  You might want
-         to install the \`Autoconf' and \`GNU m4' packages.  Grab them
+WARNING: '$1' is $msg.  You should only need it if
+         you modified 'acconfig.h' or '${configure_ac}'.  You might want
+         to install the Autoconf and GNU m4 packages.  Grab them
          from any GNU archive site."
     files=`sed -n 's/^[ ]*A[CM]_CONFIG_HEADER(\([^)]*\)).*/\1/p' ${configure_ac}`
     test -z "$files" && files="config.h"
@@ -186,9 +175,9 @@
 
   automake*)
     echo 1>&2 "\
-WARNING: \`$1' is $msg.  You should only need it if
-         you modified \`Makefile.am', \`acinclude.m4' or \`${configure_ac}'.
-         You might want to install the \`Automake' and \`Perl' packages.
+WARNING: '$1' is $msg.  You should only need it if
+         you modified 'Makefile.am', 'acinclude.m4' or '${configure_ac}'.
+         You might want to install the Automake and Perl packages.
          Grab them from any GNU archive site."
     find . -type f -name Makefile.am -print |
 	   sed 's/\.am$/.in/' |
@@ -197,10 +186,10 @@
 
   autom4te*)
     echo 1>&2 "\
-WARNING: \`$1' is needed, but is $msg.
+WARNING: '$1' is needed, but is $msg.
          You might have modified some files without having the
          proper tools for further handling them.
-         You can get \`$1' as part of \`Autoconf' from any GNU
+         You can get '$1' as part of Autoconf from any GNU
          archive site."
 
     file=`echo "$*" | sed -n "$sed_output"`
@@ -220,13 +209,13 @@
 
   bison*|yacc*)
     echo 1>&2 "\
-WARNING: \`$1' $msg.  You should only need it if
-         you modified a \`.y' file.  You may need the \`Bison' package
+WARNING: '$1' $msg.  You should only need it if
+         you modified a '.y' file.  You may need the Bison package
          in order for those modifications to take effect.  You can get
-         \`Bison' from any GNU archive site."
+         Bison from any GNU archive site."
     rm -f y.tab.c y.tab.h
     if test $# -ne 1; then
-        eval LASTARG="\${$#}"
+        eval LASTARG=\${$#}
 	case $LASTARG in
 	*.y)
 	    SRCFILE=`echo "$LASTARG" | sed 's/y$/c/'`
@@ -250,13 +239,13 @@
 
   lex*|flex*)
     echo 1>&2 "\
-WARNING: \`$1' is $msg.  You should only need it if
-         you modified a \`.l' file.  You may need the \`Flex' package
+WARNING: '$1' is $msg.  You should only need it if
+         you modified a '.l' file.  You may need the Flex package
          in order for those modifications to take effect.  You can get
-         \`Flex' from any GNU archive site."
+         Flex from any GNU archive site."
     rm -f lex.yy.c
     if test $# -ne 1; then
-        eval LASTARG="\${$#}"
+        eval LASTARG=\${$#}
 	case $LASTARG in
 	*.l)
 	    SRCFILE=`echo "$LASTARG" | sed 's/l$/c/'`
@@ -273,10 +262,10 @@
 
   help2man*)
     echo 1>&2 "\
-WARNING: \`$1' is $msg.  You should only need it if
+WARNING: '$1' is $msg.  You should only need it if
 	 you modified a dependency of a manual page.  You may need the
-	 \`Help2man' package in order for those modifications to take
-	 effect.  You can get \`Help2man' from any GNU archive site."
+	 Help2man package in order for those modifications to take
+	 effect.  You can get Help2man from any GNU archive site."
 
     file=`echo "$*" | sed -n "$sed_output"`
     test -z "$file" && file=`echo "$*" | sed -n "$sed_minuso"`
@@ -291,12 +280,12 @@
 
   makeinfo*)
     echo 1>&2 "\
-WARNING: \`$1' is $msg.  You should only need it if
-         you modified a \`.texi' or \`.texinfo' file, or any other file
+WARNING: '$1' is $msg.  You should only need it if
+         you modified a '.texi' or '.texinfo' file, or any other file
          indirectly affecting the aspect of the manual.  The spurious
-         call might also be the consequence of using a buggy \`make' (AIX,
-         DU, IRIX).  You might want to install the \`Texinfo' package or
-         the \`GNU make' package.  Grab either from any GNU archive site."
+         call might also be the consequence of using a buggy 'make' (AIX,
+         DU, IRIX).  You might want to install the Texinfo package or
+         the GNU make package.  Grab either from any GNU archive site."
     # The file to touch is that specified with -o ...
     file=`echo "$*" | sed -n "$sed_output"`
     test -z "$file" && file=`echo "$*" | sed -n "$sed_minuso"`
@@ -318,49 +307,14 @@
     touch $file
     ;;
 
-  tar*)
-    shift
-
-    # We have already tried tar in the generic part.
-    # Look for gnutar/gtar before invocation to avoid ugly error
-    # messages.
-    if (gnutar --version > /dev/null 2>&1); then
-       gnutar "$@" && exit 0
-    fi
-    if (gtar --version > /dev/null 2>&1); then
-       gtar "$@" && exit 0
-    fi
-    firstarg="$1"
-    if shift; then
-	case $firstarg in
-	*o*)
-	    firstarg=`echo "$firstarg" | sed s/o//`
-	    tar "$firstarg" "$@" && exit 0
-	    ;;
-	esac
-	case $firstarg in
-	*h*)
-	    firstarg=`echo "$firstarg" | sed s/h//`
-	    tar "$firstarg" "$@" && exit 0
-	    ;;
-	esac
-    fi
-
-    echo 1>&2 "\
-WARNING: I can't seem to be able to run \`tar' with the given arguments.
-         You may want to install GNU tar or Free paxutils, or check the
-         command line arguments."
-    exit 1
-    ;;
-
   *)
     echo 1>&2 "\
-WARNING: \`$1' is needed, and is $msg.
+WARNING: '$1' is needed, and is $msg.
          You might have modified some files without having the
-         proper tools for further handling them.  Check the \`README' file,
+         proper tools for further handling them.  Check the 'README' file,
          it often tells you about the needed prerequisites for installing
          this package.  You may also peek at any GNU archive site, in case
-         some other package would contain this missing \`$1' program."
+         some other package would contain this missing '$1' program."
     exit 1
     ;;
 esac
diff -ruN tarsnap-autoconf-1.0.32/config.h.in tarsnap-autoconf-1.0.33/config.h.in
--- tarsnap-autoconf-1.0.32/config.h.in	2012-02-22 04:10:54.000000000 -0800
+++ tarsnap-autoconf-1.0.33/config.h.in	2012-08-10 00:05:25.000000000 -0700
@@ -730,6 +730,11 @@
 /* Version number of package */
 #undef VERSION
 
+/* Enable large inode numbers on Mac OS X 10.5.  */
+#ifndef _DARWIN_USE_64_BIT_INODE
+# define _DARWIN_USE_64_BIT_INODE 1
+#endif
+
 /* Number of bits in a file offset, on hosts where this is settable. */
 #undef _FILE_OFFSET_BITS
 
diff -ruN tarsnap-autoconf-1.0.32/lib/Makefile tarsnap-autoconf-1.0.33/lib/Makefile
--- tarsnap-autoconf-1.0.32/lib/Makefile	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/lib/Makefile	2012-08-10 00:05:23.000000000 -0700
@@ -80,6 +80,7 @@
 SRCS	+=	hexlink.c
 SRCS	+=	humansize.c
 SRCS	+=	memlimit.c
+SRCS	+=	monoclock.c
 SRCS	+=	readpass.c
 SRCS	+=	sigquit.c
 SRCS	+=	tvmath.c
diff -ruN tarsnap-autoconf-1.0.32/lib/crypto/crypto_scrypt-nosse.c tarsnap-autoconf-1.0.33/lib/crypto/crypto_scrypt-nosse.c
--- tarsnap-autoconf-1.0.32/lib/crypto/crypto_scrypt-nosse.c	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/lib/crypto/crypto_scrypt-nosse.c	2012-08-10 00:05:23.000000000 -0700
@@ -252,7 +252,7 @@
 		errno = EFBIG;
 		goto err0;
 	}
-	if (((N & (N - 1)) != 0) || (N == 0)) {
+	if (((N & (N - 1)) != 0) || (N < 2)) {
 		errno = EINVAL;
 		goto err0;
 	}
diff -ruN tarsnap-autoconf-1.0.32/lib/crypto/crypto_scrypt-sse.c tarsnap-autoconf-1.0.33/lib/crypto/crypto_scrypt-sse.c
--- tarsnap-autoconf-1.0.32/lib/crypto/crypto_scrypt-sse.c	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/lib/crypto/crypto_scrypt-sse.c	2012-08-10 00:05:23.000000000 -0700
@@ -280,7 +280,7 @@
 		errno = EFBIG;
 		goto err0;
 	}
-	if (((N & (N - 1)) != 0) || (N == 0)) {
+	if (((N & (N - 1)) != 0) || (N < 2)) {
 		errno = EINVAL;
 		goto err0;
 	}
diff -ruN tarsnap-autoconf-1.0.32/lib/datastruct/rwhashtab.c tarsnap-autoconf-1.0.33/lib/datastruct/rwhashtab.c
--- tarsnap-autoconf-1.0.32/lib/datastruct/rwhashtab.c	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/lib/datastruct/rwhashtab.c	2012-08-10 00:05:23.000000000 -0700
@@ -173,6 +173,18 @@
 }
 
 /**
+ * rwhashtab_getsize(table):
+ * Return the number of entries in the table.
+ */
+size_t
+rwhashtab_getsize(RWHASHTAB * H)
+{
+
+	/* Just extract the value and return it. */
+	return (H->numentries);
+}
+
+/**
  * rwhashtab_insert(table, record):
  * Insert the provided record into the hash table.  Returns (-1) on error,
  * 0 on success, and 1 if the table already contains a record with the same
diff -ruN tarsnap-autoconf-1.0.32/lib/datastruct/rwhashtab.h tarsnap-autoconf-1.0.33/lib/datastruct/rwhashtab.h
--- tarsnap-autoconf-1.0.32/lib/datastruct/rwhashtab.h	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/lib/datastruct/rwhashtab.h	2012-08-10 00:05:23.000000000 -0700
@@ -18,6 +18,12 @@
 RWHASHTAB * rwhashtab_init(size_t, size_t);
 
 /**
+ * rwhashtab_getsize(table):
+ * Return the number of entries in the table.
+ */
+size_t rwhashtab_getsize(RWHASHTAB *);
+
+/**
  * rwhashtab_insert(table, record):
  * Insert the provided record into the hash table.  Returns (-1) on error,
  * 0 on success, and 1 if the table already contains a record with the same
diff -ruN tarsnap-autoconf-1.0.32/lib/netpacket/netpacket.h tarsnap-autoconf-1.0.33/lib/netpacket/netpacket.h
--- tarsnap-autoconf-1.0.32/lib/netpacket/netpacket.h	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/lib/netpacket/netpacket.h	2012-08-10 00:05:23.000000000 -0700
@@ -89,7 +89,7 @@
 /**
  * netpacket_transaction_start(NPC, machinenum, operation, snonce, cnonce,
  *     state, callback):
- * Construct and send a NETPACKET_TRANSACTION_GETNONCE packet asking to
+ * Construct and send a NETPACKET_TRANSACTION_START packet asking to
  * start a transaction; the transaction is a write transaction if
  * ${operation} is 0, a delete transaction if ${operation} is 1, or a fsck
  * transaction if ${operation} is 2.
diff -ruN tarsnap-autoconf-1.0.32/lib/netpacket/netpacket_op.c tarsnap-autoconf-1.0.33/lib/netpacket/netpacket_op.c
--- tarsnap-autoconf-1.0.32/lib/netpacket/netpacket_op.c	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/lib/netpacket/netpacket_op.c	2012-08-10 00:05:23.000000000 -0700
@@ -6,6 +6,7 @@
 #include <string.h>
 
 #include "crypto.h"
+#include "monoclock.h"
 #include "netpacket_internal.h"
 #include "netproto.h"
 #include "sysendian.h"
@@ -253,10 +254,8 @@
 	 * Warn the user that we're waiting, if we haven't already printed a
 	 * warning message recently.
 	 */
-	if (gettimeofday(&tp, NULL)) {
-		warnp("gettimeofday");
+	if (monoclock_get(&tp))
 		goto err0;
-	}
 	if ((nseconds >= (tarsnap_opt_noisy_warnings ? 1 : 30)) &&
 	    ((tp.tv_sec > next_connlost_warning.tv_sec) ||
 	        ((tp.tv_sec == next_connlost_warning.tv_sec) &&
diff -ruN tarsnap-autoconf-1.0.32/lib/netpacket/netpacket_transaction.c tarsnap-autoconf-1.0.33/lib/netpacket/netpacket_transaction.c
--- tarsnap-autoconf-1.0.32/lib/netpacket/netpacket_transaction.c	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/lib/netpacket/netpacket_transaction.c	2012-08-10 00:05:23.000000000 -0700
@@ -44,7 +44,7 @@
 /**
  * netpacket_transaction_start(NPC, machinenum, operation, snonce, cnonce,
  *     state, callback):
- * Construct and send a NETPACKET_TRANSACTION_GETNONCE packet asking to
+ * Construct and send a NETPACKET_TRANSACTION_START packet asking to
  * start a transaction; the transaction is a write transaction if
  * ${operation} is 0, a delete transaction if ${operation} is 1, or a fsck
  * transaction if ${operation} is 2.
diff -ruN tarsnap-autoconf-1.0.32/lib/netproto/netproto.h tarsnap-autoconf-1.0.33/lib/netproto/netproto.h
--- tarsnap-autoconf-1.0.32/lib/netproto/netproto.h	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/lib/netproto/netproto.h	2012-08-10 00:05:23.000000000 -0700
@@ -43,8 +43,8 @@
  * netproto_readpacket(C, callback_getbuf, callback_done, cookie):
  * Read a packet from the connection.  Once the type and length of the
  * packet is known, call callback_getbuf(cookie, type, buf, buflen); once
- * the packet is read or fails, call callback(cookie, status), where status
- * is a NETPROTO_STATUS_* value.
+ * the packet is read or fails, call callback_done(cookie, status), where
+ * status is a NETPROTO_STATUS_* value.
  */
 int netproto_readpacket(NETPROTO_CONNECTION *,
     int(void *, uint8_t, uint8_t **, size_t),
diff -ruN tarsnap-autoconf-1.0.32/lib/netproto/netproto_packet.c tarsnap-autoconf-1.0.33/lib/netproto/netproto_packet.c
--- tarsnap-autoconf-1.0.32/lib/netproto/netproto_packet.c	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/lib/netproto/netproto_packet.c	2012-08-10 00:05:23.000000000 -0700
@@ -295,8 +295,8 @@
  * netproto_readpacket(C, callback_getbuf, callback_done, cookie):
  * Read a packet from the connection.  Once the type and length of the
  * packet is known, call callback_getbuf(cookie, type, buf, buflen); once
- * the packet is read or fails, call callback(cookie, status), where status
- * is a NETPROTO_STATUS_* value.
+ * the packet is read or fails, call callback_done(cookie, status), where
+ * status is a NETPROTO_STATUS_* value.
  */
 int netproto_readpacket(NETPROTO_CONNECTION * C,
     int (* callback_getbuf)(void *, uint8_t, uint8_t **, size_t),
diff -ruN tarsnap-autoconf-1.0.32/lib/network/network_select.c tarsnap-autoconf-1.0.33/lib/network/network_select.c
--- tarsnap-autoconf-1.0.32/lib/network/network_select.c	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/lib/network/network_select.c	2012-08-10 00:05:23.000000000 -0700
@@ -8,6 +8,7 @@
 #include <stdlib.h>
 #include <string.h>
 
+#include "monoclock.h"
 #include "network_internal.h"
 #include "tvmath.h"
 #include "warnp.h"
@@ -160,7 +161,7 @@
 		return;
 
 	/* If we can't get the current time, do nothing. */
-	if (gettimeofday(&tnow, NULL))
+	if (monoclock_get(&tnow))
 		return;
 
 	/* Figure out how long it has been since the clock started. */
@@ -190,7 +191,7 @@
 	/* Is the clock already running? */
 	if ((select_rettime.tv_sec == 0) &&
 	    (select_rettime.tv_usec == 0)) {
-		gettimeofday(&select_rettime, NULL);
+		monoclock_get(&select_rettime);
 	}
 }
 
@@ -485,10 +486,8 @@
 
 restart:
 	/* Get current time. */
-	if (gettimeofday(&curtime, NULL)) {
-		warnp("gettimeofday()");
+	if (monoclock_get(&curtime))
 		goto err0;
-	}
 
 	/*
 	 * Figure out how long it has been since we last added tokens to the
@@ -620,10 +619,8 @@
 	selectstats_startclock();
 
 	/* Get current time so that we can detect timeouts. */
-	if (gettimeofday(&curtime, NULL)) {
-		warnp("gettimeofday()");
+	if (monoclock_get(&curtime))
 		goto err0;
-	}
 
 	/*
 	 * Scan the descriptors in decreasing order, just in case maxfd is
diff -ruN tarsnap-autoconf-1.0.32/lib/util/monoclock.c tarsnap-autoconf-1.0.33/lib/util/monoclock.c
--- tarsnap-autoconf-1.0.32/lib/util/monoclock.c	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.33/lib/util/monoclock.c	2012-08-10 00:05:23.000000000 -0700
@@ -0,0 +1,41 @@
+#include <sys/time.h>
+
+#include <time.h>
+
+#include "warnp.h"
+
+#include "monoclock.h"
+
+/**
+ * monoclock_get(tv):
+ * Store the current time in ${tv}.  If CLOCK_MONOTONIC is available, use
+ * that clock; otherwise, use gettimeofday(2).
+ */
+int
+monoclock_get(struct timeval * tv)
+{
+#ifdef CLOCK_MONOTONIC
+	struct timespec tp;
+#endif
+
+#ifdef CLOCK_MONOTONIC
+	if (clock_gettime(CLOCK_MONOTONIC, &tp)) {
+		warnp("clock_gettime(CLOCK_MONOTONIC)");
+		goto err0;
+	}
+	tv->tv_sec = tp.tv_sec;
+	tv->tv_usec = tp.tv_nsec / 1000;
+#else
+	if (gettimeofday(tv, NULL)) {
+		warnp("gettimeofday");
+		goto err0;
+	}
+#endif
+
+	/* Success! */
+	return (0);
+
+err0:
+	/* Failure! */
+	return (-1);
+}
diff -ruN tarsnap-autoconf-1.0.32/lib/util/monoclock.h tarsnap-autoconf-1.0.33/lib/util/monoclock.h
--- tarsnap-autoconf-1.0.32/lib/util/monoclock.h	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.33/lib/util/monoclock.h	2012-08-10 00:05:23.000000000 -0700
@@ -0,0 +1,13 @@
+#ifndef _MONOCLOCK_H_
+#define _MONOCLOCK_H_
+
+#include <sys/time.h>
+
+/**
+ * monoclock_get(tv):
+ * Store the current time in ${tv}.  If CLOCK_MONOTONIC is available, use
+ * that clock; otherwise, use gettimeofday(2).
+ */
+int monoclock_get(struct timeval *);
+
+#endif /* !_MONOCLOCK_H_ */
diff -ruN tarsnap-autoconf-1.0.32/lib/util/readpass.c tarsnap-autoconf-1.0.33/lib/util/readpass.c
--- tarsnap-autoconf-1.0.32/lib/util/readpass.c	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/lib/util/readpass.c	2012-08-10 00:05:23.000000000 -0700
@@ -38,7 +38,7 @@
 #define MAXPASSLEN 2048
 
 /**
- * tarsnap_getpass(passwd, prompt, confirmprompt, devtty)
+ * tarsnap_readpass(passwd, prompt, confirmprompt, devtty)
  * If ${devtty} is non-zero, read a password from /dev/tty if possible; if
  * not, read from stdin.  If reading from a tty (either /dev/tty or stdin),
  * disable echo and prompt the user by printing ${prompt} to stderr.  If
diff -ruN tarsnap-autoconf-1.0.32/lib/util/readpass.h tarsnap-autoconf-1.0.33/lib/util/readpass.h
--- tarsnap-autoconf-1.0.32/lib/util/readpass.h	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/lib/util/readpass.h	2012-08-10 00:05:23.000000000 -0700
@@ -30,7 +30,7 @@
 #define _READPASS_H_
 
 /**
- * tarsnap_getpass(passwd, prompt, confirmprompt, devtty)
+ * tarsnap_readpass(passwd, prompt, confirmprompt, devtty)
  * If ${devtty} is non-zero, read a password from /dev/tty if possible; if
  * not, read from stdin.  If reading from a tty (either /dev/tty or stdin),
  * disable echo and prompt the user by printing ${prompt} to stderr.  If
diff -ruN tarsnap-autoconf-1.0.32/lib/util/tvmath.c tarsnap-autoconf-1.0.33/lib/util/tvmath.c
--- tarsnap-autoconf-1.0.32/lib/util/tvmath.c	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/lib/util/tvmath.c	2012-08-10 00:05:23.000000000 -0700
@@ -2,23 +2,22 @@
 
 #include <sys/time.h>
 
+#include "monoclock.h"
 #include "warnp.h"
 
 #include "tvmath.h"
 
 /**
  * tvmath_addctime(tv):
- * Set tv += gettimeofday.
+ * Set tv += monoclock.
  */
 int
 tvmath_addctime(struct timeval * tv)
 {
 	struct timeval tnow;
 
-	if (gettimeofday(&tnow, NULL)) {
-		warnp("gettimeofday");
+	if (monoclock_get(&tnow))
 		goto err0;
-	}
 	tv->tv_sec += tnow.tv_sec;
 	tv->tv_usec += tnow.tv_usec;
 	if (tv->tv_usec >= 1000000) {
@@ -36,17 +35,15 @@
 
 /**
  * tvmath_subctime(tv):
- * Set tv -= gettimeofday.
+ * Set tv -= monoclock.
  */
 int
 tvmath_subctime(struct timeval * tv)
 {
 	struct timeval tnow;
 
-	if (gettimeofday(&tnow, NULL)) {
-		warnp("gettimeofday");
+	if (monoclock_get(&tnow))
 		goto err0;
-	}
 	tv->tv_sec -= tnow.tv_sec;
 	tv->tv_usec -= tnow.tv_usec;
 	if (tv->tv_usec < 0) {
@@ -64,17 +61,15 @@
 
 /**
  * tvmath_rsubctime(tv):
- * Set tv = gettimeofday - tv.
+ * Set tv = monoclock - tv.
  */
 int
 tvmath_rsubctime(struct timeval * tv)
 {
 	struct timeval tnow;
 
-	if (gettimeofday(&tnow, NULL)) {
-		warnp("gettimeofday");
+	if (monoclock_get(&tnow))
 		goto err0;
-	}
 	tv->tv_sec = tnow.tv_sec - tv->tv_sec;
 	tv->tv_usec = tnow.tv_usec - tv->tv_usec;
 	if (tv->tv_usec < 0) {
diff -ruN tarsnap-autoconf-1.0.32/lib/util/tvmath.h tarsnap-autoconf-1.0.33/lib/util/tvmath.h
--- tarsnap-autoconf-1.0.32/lib/util/tvmath.h	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/lib/util/tvmath.h	2012-08-10 00:05:23.000000000 -0700
@@ -5,19 +5,19 @@
 
 /**
  * tvmath_addctime(tv):
- * Set tv += gettimeofday.
+ * Set tv += monoclock.
  */
 int tvmath_addctime(struct timeval *);
 
 /**
  * tvmath_subctime(tv):
- * Set tv -= gettimeofday.
+ * Set tv -= monoclock.
  */
 int tvmath_subctime(struct timeval *);
 
 /**
  * tvmath_rsubctime(tv):
- * Set tv = gettimeofday - tv.
+ * Set tv = monoclock - tv.
  */
 int tvmath_rsubctime(struct timeval *);
 
diff -ruN tarsnap-autoconf-1.0.32/libarchive/archive_read_disk_set_standard_lookup.c tarsnap-autoconf-1.0.33/libarchive/archive_read_disk_set_standard_lookup.c
--- tarsnap-autoconf-1.0.32/libarchive/archive_read_disk_set_standard_lookup.c	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/libarchive/archive_read_disk_set_standard_lookup.c	2012-08-10 00:05:23.000000000 -0700
@@ -83,7 +83,7 @@
  * a simple cache to accelerate such lookups---into the archive_read_disk
  * object.  This is in a separate file because getpwuid()/getgrgid()
  * can pull in a LOT of library code (including NIS/LDAP functions, which
- * pull in DNS resolveers, etc).  This can easily top 500kB, which makes
+ * pull in DNS resolvers, etc).  This can easily top 500kB, which makes
  * it inappropriate for some space-constrained applications.
  *
  * Applications that are size-sensitive may want to just use the
diff -ruN tarsnap-autoconf-1.0.32/libarchive/archive_write_disk_set_standard_lookup.c tarsnap-autoconf-1.0.33/libarchive/archive_write_disk_set_standard_lookup.c
--- tarsnap-autoconf-1.0.32/libarchive/archive_write_disk_set_standard_lookup.c	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/libarchive/archive_write_disk_set_standard_lookup.c	2012-08-10 00:05:23.000000000 -0700
@@ -67,7 +67,7 @@
  * a simple cache to accelerate such lookups---into the archive_write_disk
  * object.  This is in a separate file because getpwnam()/getgrnam()
  * can pull in a LOT of library code (including NIS/LDAP functions, which
- * pull in DNS resolveers, etc).  This can easily top 500kB, which makes
+ * pull in DNS resolvers, etc).  This can easily top 500kB, which makes
  * it inappropriate for some space-constrained applications.
  *
  * Applications that are size-sensitive may want to just use the
diff -ruN tarsnap-autoconf-1.0.32/pkg/debian/changelog tarsnap-autoconf-1.0.33/pkg/debian/changelog
--- tarsnap-autoconf-1.0.32/pkg/debian/changelog	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/pkg/debian/changelog	2012-08-10 00:05:23.000000000 -0700
@@ -1,3 +1,11 @@
+tarsnap (1.0.33) unstable; urgency=low
+
+  * New version of tarsnap brings reduced memory usage on systems with a
+    large amount of stored data; faster operation for --fsck and when
+    deleting or printing statistics for multiple archives; and corrects
+    a bug in the handling of the --newerXXX option.
+
+ -- Colin Percival <cperciva@tarsnap.com>  Wed, 1 Aug 2002 23:52:10 +0000
 tarsnap (1.0.32) unstable; urgency=low
 
   * New version of tarsnap fixes a bug which made the --nodump option
diff -ruN tarsnap-autoconf-1.0.32/tar/bsdtar.c tarsnap-autoconf-1.0.33/tar/bsdtar.c
--- tarsnap-autoconf-1.0.32/tar/bsdtar.c	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/tar/bsdtar.c	2012-08-10 00:05:23.000000000 -0700
@@ -999,12 +999,11 @@
 	"  --cachedir <directory>  Cache directory\n"
 	"  -v    Verbose\n"
 	"  -w    Interactive\n"
-	"Create: %p -c [options] [<file> | <dir> | @<archive> | -C <dir> ]\n"
+	"Create: %p -c [options] [<file> | <dir> | @@<archive> | -C <dir>] ...\n"
 	"  <file>, <dir>  add these items to archive\n"
 	"  --exclude <pattern>  Skip files that match pattern\n"
 	"  -C <dir>  Change to <dir> before processing remaining files\n"
-	"  @<filename>  Add entries from archive <filename>\n"
-	"  @@ <archive>  Add entries from tarsnap archive <archive>\n"
+	"  @@<archive>  Add entries from tarsnap archive <archive>\n"
 	"List: %p -t [options] [<patterns>]\n"
 	"  <patterns>  If specified, list only entries that match\n"
 	"Extract: %p -x [options] [<patterns>]\n"
diff -ruN tarsnap-autoconf-1.0.32/tar/chunks/chunks.h tarsnap-autoconf-1.0.33/tar/chunks/chunks.h
--- tarsnap-autoconf-1.0.32/tar/chunks/chunks.h	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/tar/chunks/chunks.h	2012-08-10 00:05:23.000000000 -0700
@@ -19,6 +19,13 @@
 CHUNKS_R * chunks_read_init(STORAGE_R *, size_t);
 
 /**
+ * chunks_read_cache(C, hash):
+ * Using the read cookie ${C}, tell the storage layer to cache the chunk with
+ * HMAC ${hash} after it is read.
+ */
+int chunks_read_cache(CHUNKS_R *, const uint8_t *);
+
+/**
  * chunks_read_chunk(C, hash, len, zlen, buf, quiet):
  * Using the read cookie ${C}, read the chunk with HMAC ${hash}
  * into ${buf}; it should have length ${len} and compressed size ${zlen}.
@@ -101,6 +108,12 @@
 CHUNKS_D * chunks_delete_start(const char *, STORAGE_D *);
 
 /**
+ * chunks_delete_getdirsz(C):
+ * Return the number of entries in the chunks directory associated with ${C}.
+ */
+size_t chunks_delete_getdirsz(CHUNKS_D *);
+
+/**
  * chunks_delete_chunk(C, hash):
  * Delete the chunk with HMAC ${hash} as part of the delete transaction
  * associated with the cookie ${C}.  Note that chunks are actually
@@ -178,6 +191,12 @@
 CHUNKS_S * chunks_stats_init(const char *);
 
 /**
+ * chunks_stats_getdirsz(C):
+ * Return the number of entries in the chunks directory associated with ${C}.
+ */
+size_t chunks_stats_getdirsz(CHUNKS_S *);
+
+/**
  * chunks_stats_printglobal(stream, C):
  * Print global statistics relating to a set of archives.
  */
